# FstScan


Check window sizes

```bash

# Use the 3 longest chromosomes and the Rscript from ngsLD 
# xx.ld_sampled.gz is output from LD pruning step
for i in 1 2 3 ;
do ls ModernPuffinAngsd_chromosome_${i}.ld_sampled.gz | Rscript --vanilla --slave fit_LDdecay.R --max_kb_dist 100 --fit_boot 100 --fit_level 20 --plot_data --plot_scale 3 -o ModernPuffinAngsd_${i}.LD_r2.pdf ;
done ;

A 50-kb window size was chosen for sliding window analyses because LD has decayed within this distance by ca 10%
```

Fst window-based analysis

```bash

module purge
module load angsd/0.931-GCC-8.2.0-2.31.1

# get the sliding window estimate
for pop1 in SPI IOM CAN ROS ;
do pop2=MAI ;
realSFS fst stats2 ${pop1}.${pop2}.fst.idx -fold 1 -win 50000 -step 12500 > ${pop1}.${pop2}.slidingWindowFst ;
done ;


```

the resulting file can be visualised in R (ggplot2 etc.)
