# Main ANGSD

```bash

echo -e "Scaffolds_chromosome_10:\nScaffolds_chromosome_11:\nScaffolds_chromosome_12:\nScaffolds_chromosome_13:\nScaffolds_chromosome_14:\nScaffolds_chromosome_15:\nScaffolds_chromosome_16:\nScaffolds_chromosome_17:\nScaffolds_chromosome_18:\nScaffolds_chromosome_19:\nScaffolds_chromosome_1:\nScaffolds_chromosome_20:\nScaffolds_chromosome_21:\nScaffolds_chromosome_22:\nScaffolds_chromosome_23:\nScaffolds_chromosome_24:\nScaffolds_chromosome_25:\nScaffolds_chromosome_2:\nScaffolds_chromosome_3:\nScaffolds_chromosome_4:\nScaffolds_chromosome_5:\nScaffolds_chromosome_6:\nScaffolds_chromosome_7:\nScaffolds_chromosome_8:\nScaffolds_chromosome_9:\nScaffolds_chromosome_Z:\nScaffolds_unplaced:" > ChromosomeList

cat ChromosomeList | while read i ;
do echo ${i} ;
sbatch Puffin_ANGSD_main.sh ${i} ;
done
```

nano Puffin_ANGSD_main.sh

```bash
#!/bin/bash


Chromosome=$(echo ${1} | awk -F ':' '{print $1}' | awk -F '_' '{print $2"_"$3}')

FILTERS="-uniqueOnly 1 -remove_bads 1 -minMapQ 30 -minQ 30 -dosnpstat 1 -C 50 -baq 2 -checkBamHeaders 1 -doHWE 1 -HWE_pval 1e-2 -sb_pval 1e-5 -hetbias_pval 1e-5 -skipTriallelic 1 -minInd 71 -snp_pval 1e-6 -minMaf 0.05 -setMaxDepth 635 -setMinDepth 365"
TODO="-doMajorMinor 1 -doMaf 1 -doCounts 1 -doGeno 8 -doPost 1 -doGlf 2"

module load angsd/0.931-GCC-8.2.0-2.31.1

Threads="16"

angsd -b bams_good -GL 1 $FILTERS $TODO -P ${Threads} -ref Assembly_Puffin_NU.MT.fasta -r ${1} -out ModernPuffinAngsd_${Chromosome}

rm -r temp.${1}
```

SUMMARY

```bash
zcat ModernPuffinAngsd_chromosome_1.mafs.gz > ModernPuffinAngsd_All.mafs

for i in 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 2 3 4 5 6 7 8 9 Z;
do zcat ModernPuffinAngsd_chromosome_${i}.mafs.gz | tail -n +2 >> ModernPuffinAngsd_All.mafs ;
done ;
zcat ModernPuffinAngsd_unplaced_.mafs.gz | tail -n +2 >> ModernPuffinAngsd_All.mafs ;
gzip ModernPuffinAngsd_All.mafs
zcat ModernPuffinAngsd_All.mafs.gz | tail -n +2 | wc -l

```