# LD pruning

ngsLD

```bash
sed -i 's/Scaffolds_//g' ChromosomeList
sed -i 's/://g' ChromosomeList
sed -i 's/unplaced/unplaced_/g' ChromosomeList

cat ChromosomeList | while read i ;
do echo ${i} ;
sbatch Puffin_ngsLD_decay.sh ${i} ;
done

```

-> Puffin_ngsLD_decay.sh

```bash
#!/bin/bash

zcat ModernPuffinAngsd_${1}.mafs.gz | cut -f 1,2 | tail -n +2 > ModernPuffinAngsd_${1}.pos
NS=$(cat ModernPuffinAngsd_${1}.pos | wc -l)
echo "Number of sites = "$NS

#ngsLD
module load ngsLD/191108-GCC-8.2.0-2.31.1

ngsLD --n_threads 16 --geno ModernPuffinAngsd_${1}.beagle.gz --pos ModernPuffinAngsd_${1}.pos --probs --n_ind 71 --n_sites $NS --max_kb_dist 50 | gzip --best > ModernPuffinAngsd_${1}.ld.gz

```

Pruning

```bash
cat ChromosomeList | while read i ;
do echo ${i} ;
sbatch Puffin_LDpruning.sh ${i} ;
done
#takes 24hrs
```

-> Puffin_LDpruning.sh

```bash
#!/bin/bash

module load OrthoMCL/2.0.9-intel-2018b-Perl-5.28.0

gunzip ModernPuffinAngsd_${1}.ld.gz
gunzip ModernPuffinAngsd_${1}.beagle.gz
tail -n +2 ModernPuffinAngsd_${1}.beagle > ModernPuffinAngsd_${1}.beagle.edit

mcl <(cut -f1,2,7 ModernPuffinAngsd_${1}.ld | awk '$3>0.2') --abc -I 2.0 -o ModernPuffinAngsd_${1}.ld.mcl

#non-cluster snps
awk '{print $1"\t"$2"\t"$7}' ModernPuffinAngsd_${1}.ld | awk '$3>0.2' | awk '{print $1}' > tmp1
awk '{print $1"\t"$2"\t"$7}' ModernPuffinAngsd_${1}.ld | awk '$3>0.2' | awk '{print $2}' > tmp2
cat tmp1 tmp2 | sort | uniq > cluster.snps
sed -i 's/:/_/g' cluster.snps
rm tmp1
rm tmp2
LANG=C fgrep -v -w -f cluster.snps ModernPuffinAngsd_${1}.beagle.edit > tmp1

#rep snps of cluster
touch Rep.snps
TotalLines=$(cat ModernPuffinAngsd_${1}.ld.mcl | wc -l)
echo "Number of total lines = "$TotalLines
for line in $(seq 1 1 $TotalLines) ;
do ColumnNumbers=$(head -${line} ModernPuffinAngsd_${1}.ld.mcl | tail -1 | awk '{print NF}' | sort -nu | tail -n 1) ;
AlmostMiddleColumn=$(bc <<<"scale=0; $ColumnNumbers / 2" ) ;
let "MiddleColumn=$AlmostMiddleColumn+1" ;
Scaffold=$(head -${line} ModernPuffinAngsd_${1}.ld.mcl | tail -1 | awk -v VAR=$MiddleColumn '{print $VAR}') ;
echo $Scaffold >> Rep.snps ;
done ;

cat Rep.snps | sort | uniq > Rep.snps.uniq
sed -i 's/:/_/g' Rep.snps.uniq

LANG=C fgrep -w -f Rep.snps.uniq ModernPuffinAngsd_${1}.beagle.edit > tmp2

#merging
cat tmp1 tmp2 | sort -t '_' -n -k4,4 > ModernPuffinAngsd_${1}.beagle.tmp
head -1 ModernPuffinAngsd_${1}.beagle | cat - ModernPuffinAngsd_${1}.beagle.tmp > ModernPuffinAngsd_${1}.beagle.ldpruned
gzip ModernPuffinAngsd_${1}.beagle.ldpruned

```

Combine chromosomes

```bash
#ALL
zcat ModernPuffinAngsd_chromosome_1.beagle.ldpruned.gz > ModernPuffinAngsd_All.beagle.ldpruned

for i in 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 2 3 4 5 6 7 8 9 Z ;
do zcat ModernPuffinAngsd_chromosome_${i}.beagle.ldpruned.gz | tail -n +2 >> ModernPuffinAngsd_All.beagle.ldpruned ;
done ;
zcat ModernPuffinAngsd_unplaced_.beagle.ldpruned.gz | tail -n +2 >> ModernPuffinAngsd_All.beagle.ldpruned ;
gzip ModernPuffinAngsd_All.beagle.ldpruned
zcat ModernPuffinAngsd_All.beagle.ldpruned.gz | tail -n +2 | wc -l


#No Z or unplaced
zcat ModernPuffinAngsd_chromosome_1.beagle.ldpruned.gz > ModernPuffinAngsd_NotAll.beagle.ldpruned
for i in 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 2 3 4 5 6 7 8 9;
do zcat ModernPuffinAngsd_chromosome_${i}.beagle.ldpruned.gz | tail -n +2 >> ModernPuffinAngsd_NotAll.beagle.ldpruned ;
done ;
gzip ModernPuffinAngsd_NotAll.beagle.ldpruned
mv ModernPuffinAngsd_NotAll.beagle.ldpruned.gz ModernPuffinAngsd_NoZ_NoUnpl.beagle.ldpruned.gz
zcat ModernPuffinAngsd_NoZ_NoUnpl.beagle.ldpruned.gz | tail -n +2 | wc -l

```